export interface AnyAction {
    type: any;
    data?: any;
    target?: string;
}
declare type CompositeConfiguration<T, A, Act extends AnyAction> = T extends object ? {
    [K in keyof T]?: Configuration<T[K], A, Act, K extends keyof A ? K : null>;
} : undefined | null;
declare type Configuration<T, A, Act extends AnyAction, C extends keyof A | null = null> = (C extends keyof A ? {
    [K in keyof A[C]]?: (state: T, data: A[C][K]) => T;
} : {
    [K in keyof A]?: (state: T, data: A[K]) => T;
}) & ({
    [DEFAULT]?: (state: T, action: Act) => T;
    [COMPOSE]?: CompositeConfiguration<T, A, Act>;
} | {
    [DEFAULT]?: (state: T, action: Act) => T;
    [COMPOSE_NULLISH]?: CompositeConfiguration<T, A, Act>;
});
interface createReducer {
    <T, A, Act extends AnyAction = AnyAction>(config: Configuration<T, A, Act>, initialState: T): (state: T | undefined, action: Act) => T;
}
declare const createReducer: createReducer;
export declare const COMPOSE: unique symbol;
export declare const COMPOSE_NULLISH: unique symbol;
export declare const DEFAULT: unique symbol;
export default createReducer;
